//Part of the JDSA Program.  Tom Boulay, Kadonaga Lab, All Rights Reserved (2004).  
//While no known computer problems have occured as a result of using the JDSA, users assume all risk in using the JDSA.
//Please cite CY Lim et al (2004) if you use the JDSA

import java.io.*;
import java.util.*;

class GeneParse
{
  public int numofhits = 0;
  public int[] hits;
  String oldcomplement = "";
  String oldoperator = ")";
  char[] parsechars;
  int charnum = 0;
  int lengthofparsechars = 0;
  int currentlyonpositive = 0;
  String nowchecking = "";
  String operator = ")";
  public String genename, oldgenename;
  public String[] parsingresults;
  int oldnumber = 0;
  int iterations = 1;
  int currentnumber;
  char[] checking;
  String buildingnum;
  String buildingtemp = "";
  boolean[] hitcomplement;
  boolean dummy = true;
  String leader;
  public int bn = 0;

  public GeneParse(StringBuffer in_sb, int in_numofhits, int[] in_hits, boolean[] in_complement, String in_leader)
  {
    genename = "Start of File.";
    oldgenename = "Start of File.";
    numofhits = in_numofhits;
    hits = new int[numofhits];
    hitcomplement = new boolean[numofhits];
    parsingresults = new String[numofhits];
    hits = in_hits;
    hitcomplement = in_complement;
    leader = in_leader;
    parsechars = in_sb.toString().toCharArray();
    lengthofparsechars = parsechars.length;
    nowchecking = "";

    LineLoop:
    do
    {
      if (charnum >= parsechars.length) break LineLoop;
      if (parsechars[charnum] != '$')
      {
        nowchecking += parsechars[charnum];
        ++charnum;
      }
      if (parsechars[charnum] == '$')
      {
        ++charnum;
        if (nowchecking != null && nowchecking.indexOf("gene=\"") >= 0)
        {
          int tempint = nowchecking.indexOf("gene=\"");
          if ((genename.indexOf("[C]") == -1 && nowchecking.indexOf(genename) == -1) ||(genename.indexOf("[C]") >= 0 && nowchecking.indexOf(genename.substring(0, (genename.length() - 4))) == -1))
            {
            oldgenename = genename;
            genename = nowchecking.substring((nowchecking.indexOf("\"") + 1), nowchecking.lastIndexOf("\""));
            }
         
        }
        else if (nowchecking.indexOf("CDS") > 0)
        {
          if (nowchecking.indexOf("complement") >= 0 && genename.indexOf("[C]") == -1 && genename.indexOf("Start of File") == -1) genename += " [C]";
          nowchecking = nowchecking.substring(nowchecking.indexOf("CDS"), nowchecking.length());
          RNALoop:
          if (nowchecking.length() > 5 && nowchecking.indexOf("CDS") == 0)
          {
            if (nowchecking.indexOf("(") > 0)
            {
              if (nowchecking.indexOf(")") == -1)
              {
                do
                {
                  nowchecking += parsechars[charnum];
                  ++charnum;
                }
                while (nowchecking.indexOf(")") == -1)
                  ;
                while (parsechars[charnum] != '$')
                {
                  if (nowchecking == "")
                  {
                   System.out.println("Before: "+nowchecking);
                   nowchecking = parsechars.toString();
                   System.out.println("After: "+nowchecking);
                  }
                  else
                    nowchecking += parsechars[charnum];
                  ++charnum;
                }
                charnum = charnum + 1;
                }
            }
            else
            nowchecking += ")";
            checking = nowchecking.toCharArray();
            buildingnum = "";
            buildingtemp = "";
            for (int i = 0; i < checking.length; ++i)
            {
              if (Character.isDigit(checking[i]))
              {
                buildingtemp += checking[i];
              }
              else if (buildingtemp.length() > 2)
              {
                bn = 0;
                bn = Integer.parseInt(buildingtemp);
                buildingtemp = "";
                IterationLoop:
                for (int k = currentlyonpositive; k < numofhits; ++k)
                {
                  if (bn >= hits[k] && hits[k] > oldnumber)
                  {
                    parsingresults[k] = functionparse(hits[k], bn, oldnumber, genename, oldgenename, operator, hitcomplement[k]);
                    ++currentlyonpositive;
                  }
                  else
                  {
                    oldnumber = bn;
                    break IterationLoop;
                  }
                }
                if (i >= 1)
                {
                  if (Character.isDigit(checking[(i - 1)]) && checking[i] == '.' && checking[(i + 1)] == '.')
                  {
                    operator = "..";
                  }
                  if (Character.isDigit(checking[(i - 1)]) && checking[i] == ',')
                  {
                    operator = ",";
                  }
                  if (Character.isDigit(checking[(i - 1)]) && checking[i] == ')')
                  {
                   operator = ")";
                  }
                }
              }
            }
          } //end of mRNA

        
      } //end of if indexof. = CDS
      if (currentlyonpositive == numofhits) break LineLoop;
  nowchecking = "";  
  }//end of if char=$
    

  }
  while (currentlyonpositive < numofhits && charnum <= parsechars.length)
    ;
  if (currentlyonpositive < numofhits)
    {
      for (int fi = currentlyonpositive; fi < numofhits; ++fi)
         {
         parsingresults[fi] = functionparse(hits[fi],5000000,bn,"End of file.", genename, ")", hitcomplement[fi]);          
         }
    }
}

public static String functionparse(int inhit, int inbuiltnum, int inoldnumber, String ingenename, String inoldgenename, String inoperator, boolean ishitcomplement)
{
  String tobereturned = "";
  if (inoperator == "..") 
    {
      tobereturned = "In ORF: "+ingenename+"; Start of exon <-- {"+(int)(inhit - inoldnumber)+" bp} SEQUENCE FOUND ";
      if (ishitcomplement == true) tobereturned += "complement strand ";
      tobereturned += "{"+(inbuiltnum - inhit)+"bp} --> end of exon";
      return tobereturned;
    }
  if (inoperator == ",")
    {
      tobereturned = "In Intron of gene: "+ingenename+"; Previous exon <-- {"+(int)(inhit - inoldnumber)+" bp} SEQUENCE FOUND ";
      if (ishitcomplement == true) tobereturned += "complement strand ";
      tobereturned += "{"+(inbuiltnum - inhit)+"bp} --> next exon";
      return tobereturned;
    }
  if (inoperator == ")")
    {
      tobereturned = "Extragenic: Previous gene:"+inoldgenename+"<-- {"+(int)(inhit - inoldnumber)+" bp} SEQUENCE FOUND ";
      if (ishitcomplement == true) tobereturned += "complement strand ";
      tobereturned += "{"+(inbuiltnum - inhit)+"bp} --> "+ingenename ;
      return tobereturned;
    }
    return "Operator error.";
}



}



