//Part of the JDSA Program.  Tom Boulay, Kadonaga Lab, All Rights Reserved (2004).  
//While no known computer problems have occured as a result of using the JDSA, users assume all risk in using the JDSA.
//Please cite CY Lim et al (2004) if you use the JDSA

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.net.*;

class JDSASearch extends JDialog implements ActionListener
{
        private JFrame parentFrame;
        private JPanel topPanel;
        private String[] fragment = {"","","","","","","","","",""};
        private int[] tol = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
        public GeneParse GPsub;
        public int[] resultantnums = new int[15000];
        String[] found_matching_sequence = new String[15000];
        char[] current;
        int comparison = -1;
        int results = 0;
        int sflt = 0;
        int parse_counter = 0;
        int[] n_max = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
        int[] n_min = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
        public int[] gi = new int[5000];
        public String[] gi_descriptor = new String[5000];
        public boolean[] iscomplementstrand = new boolean[15000];
        public BufferedReader in;
        String currentread = "";
        String tempstring = "";
        int number_of_sequence_fragments;
        int totalnum = 0;
        public String[] resultstrings = new String[15000];
        boolean pullcds = false;
        public String resultanthits = "";
        public String[] genome = new String[50];
        int number_of_fasta_fragments = 0;
        String[] fasta_descriptors = new String[50];
        public boolean haderrors = false;
        public boolean gotresults = false;
        public boolean this_is_a_fasta_file = false;
        public JProgressBar progress;
        public JButton gosearch;
        public JLabel filescompleted;
        public JLabel hitsfound;
        private int initerations, number_of_files_to_search;
        private String[] infrags;
        private int[] inmismatch, inmin, inmax, inrefs, current_positive_for_sequence_fragment;
        int searchtype = 0;
        int found_fragment_number = 0;
        boolean shouldparse = false;
        File[] templatefiles;
        String genomeholder = "";
        int strandfiler_yes_or_no = 0; // 0 means no, 1 means top only, 2 means complement only.

        public JDSASearch(JFrame parentFrame, boolean in_shouldparse, int initerations, String[] infrags, int[] inmismatch, int[] inmin, int[] inmax,
                int insearchtype, int[] refs, File[] incoming_files, int strandfilt)
        {
                super(parentFrame);
                this.parentFrame = parentFrame;
                setTitle("Searching....");
                setSize(310, 130);
                topPanel = new JPanel();
                topPanel.setPreferredSize(new Dimension(310, 130));
                getContentPane().add(topPanel);
                topPanel.setLayout(new FlowLayout());
                setDefaultCloseOperation(DISPOSE_ON_CLOSE);
                shouldparse = in_shouldparse;
                templatefiles = incoming_files;
                strandfiler_yes_or_no = strandfilt;
                searchtype = insearchtype;
                templatefiles = incoming_files;
                filescompleted = new JLabel("Search progress: Press START");
                filescompleted.setPreferredSize(new Dimension(280, 24));
                hitsfound = new JLabel("Hits found: 0");
                hitsfound.setPreferredSize(new Dimension(280, 24));
                topPanel.add(filescompleted);
                topPanel.add(hitsfound);
                progress = new JProgressBar();
                progress.setPreferredSize(new Dimension(300, 20));
                progress.setMinimum(0);
                progress.setValue(0);
                progress.setBounds(0, 0, 0, 0);
                topPanel.add(progress);
                gosearch = new JButton("Start Search");
                topPanel.add(gosearch);
                gosearch.addActionListener(this);
                //------ End Swing GUI
                inrefs = new int[initerations];
                current_positive_for_sequence_fragment = new int[initerations];
                for (int starter = 0; starter < initerations; ++starter)
                {
                        fragment[starter] = infrags[starter];
                        tol[starter] = inmismatch[starter];
                        n_max[starter] = inmax[starter];
                        n_min[starter] = inmin[starter];
                        inrefs[starter] = refs[starter];
                }
                number_of_sequence_fragments = initerations;

                this.addWindowListener(new WindowAdapter()
                                       {
                                               public void windowClosing(WindowEvent e)
                                               {}
                                       }
                                      );
        }


        public void actionPerformed (ActionEvent event)
        {
                if (event.getSource() == gosearch)
                        try
                        {

                                //----- clean-out spaceholders for results
                                for (int initialization = 0; initialization < 15000; ++initialization)
                                {
                                        resultantnums[initialization] = 0;
                                        resultstrings[initialization] = "";
                                        found_matching_sequence[initialization] = "";
                                }
                                //----- end clean-out

                                if (searchtype == 1)
                                        number_of_files_to_search = templatefiles.length;
                                else if (searchtype == 2)
                                {
                                        File internet_source_input_file = templatefiles[0];
                                        BufferedReader internet_source_input_reader = new BufferedReader(new FileReader(internet_source_input_file));
                                        String internet_source_file_read = "";
                                        char[] array_of_line_of_file_read;
                                        String to_go_into_number = "";
                                        String to_go_into_descriptor = "";
                                        int array_counter = 0;
                                        number_of_files_to_search = 0;
                                        //---------- Calculate number of entries in single file containing list of NCBI files
                                        do
                                        {
                                                internet_source_file_read = internet_source_input_reader.readLine();
                                                if (internet_source_file_read != null)
                                                {
                                                        internet_source_file_read = internet_source_file_read.trim();
                                                        array_of_line_of_file_read = internet_source_file_read.toCharArray();
                                                        array_counter = 0;
                                                        to_go_into_number = "";
                                                        GI_Loop:
                                                        while (Character.isDigit(array_of_line_of_file_read[array_counter]))
                                                        {
                                                                to_go_into_number += array_of_line_of_file_read[array_counter];
                                                                ++array_counter;
                                                                if (array_of_line_of_file_read.length == array_counter)
                                                                        break GI_Loop;
                                                        }
                                                        gi[number_of_files_to_search] = Integer.parseInt(to_go_into_number);
                                                        if (internet_source_file_read.indexOf("\"") > 0 &&
                                                                (internet_source_file_read.indexOf("\"") != internet_source_file_read.lastIndexOf("\"")))
                                                        {
                                                                to_go_into_descriptor = "";
                                                                array_counter = (internet_source_file_read.indexOf("\"") + 1);
                                                                Descriptor_Loop:
                                                                while (array_of_line_of_file_read[array_counter] != '\"')
                                                                {
                                                                        to_go_into_descriptor += array_of_line_of_file_read[array_counter];
                                                                        ++array_counter;
                                                                        if (array_of_line_of_file_read.length == array_counter)
                                                                                break Descriptor_Loop;
                                                                }
                                                                gi_descriptor[number_of_files_to_search] = to_go_into_descriptor;
                                                                to_go_into_descriptor = "";
                                                        }
                                                        else
                                                                gi_descriptor[number_of_files_to_search] = to_go_into_number;
                                                        to_go_into_number = "";
                                                        ++number_of_files_to_search;
                                                }
                                        }
                                        while (internet_source_file_read != null)
                                                ;
                                        internet_source_input_reader.close();
                                        //--------------- End getting number of files from single local file
                                }

                                progress.setMaximum(number_of_files_to_search);
                                SearchLoop:
                                for (int current_file = 0; current_file < number_of_files_to_search; current_file++)
                                {

                                        StringBuffer geneinfo = new StringBuffer();
                                        found_fragment_number = 0;
                                        if (searchtype == 2)
                                        {
                                                URL inetfile =
                                                        new URL("http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?cmd=Retrieve&db=Nucleotide&list_uids="+
                                                        gi[current_file] + "&dopt=GenBank");
                                                URLConnection infile = inetfile.openConnection();
                                                in = new BufferedReader(new InputStreamReader(infile.getInputStream()));
                                        }
                                        else
                                        {
                                                File input = templatefiles[current_file];
                                                in = new BufferedReader(new FileReader(input));
                                        }
                                        // ------- Process file headers into geneinfo StringBuffer
                                        // ------- Adds '$' to the end of everyline not identified as one containing sequence.
                                        this_is_a_fasta_file = false;
                                        number_of_fasta_fragments = 0;
                                        genomeholder = "";
                                        for (int fasta_initialization = 0; fasta_initialization < 50; ++fasta_initialization)
                                        {
                                                fasta_descriptors[fasta_initialization] = "";
                                                genome[fasta_initialization] = "";
                                        }
                                        currentread = in.readLine();
                                        if (currentread != null) current = currentread.trim().toCharArray();
                                        if (currentread != null && currentread.indexOf(">") == 0 )
                                        {
                                                shouldparse = false;
                                                this_is_a_fasta_file = true;
                                        }
                                        if (this_is_a_fasta_file == false)
                                        {
                                                do
                                                {
                                                        if (currentread != null && currentread.trim().length() > 4)
                                                        {
                                                                if (shouldparse == true &&
                                                                        ((!(Character.isDigit(current[0]) && Character.isWhitespace(current[1]) &&
                                                                        Character.isLetter(current[2]) && Character.isLetter(current[3])))))
                                                                {
                                                                        geneinfo.append(currentread);
                                                                        geneinfo.append("$");
                                                                }
                                                        }
                                                        currentread = in.readLine();
                                                        if (currentread != null && currentread.length() < 4) currentread += "xxxx";
                                                        if (currentread != null) current = currentread.trim().toCharArray();                                                    
                                                }
                                                while (currentread != null && !(Character.isDigit(current[0]) && Character.isWhitespace(current[1]) &&
                                                        Character.isLetter(current[2]) && Character.isLetter(current[3])));
                                        }
                                        //---------  End processing of File headers (HeaderLoop)
                                        //---------  Move letters in rest of file into genomebuff then into the String genome
                                        StringBuffer genomebuff = new StringBuffer();
                                        StringBuffer_Loop:
                                        do
                                        {
                                                if (this_is_a_fasta_file == false)
                                                {
                                                        for (int x = 0; x < current.length; x++)
                                                        {
                                                                if (Character.isLetter(current[x]))
                                                                {
                                                                        genomebuff.append(current[x]);
                                                                }
                                                        }
                                                        currentread = in.readLine();
                                                        if (currentread != null)
                                                        {
                                                                currentread = currentread.trim();
                                                                current = currentread.toCharArray();
                                                                if (!Character.isDigit(current[0]))
                                                                        break StringBuffer_Loop;
                                                        }
                                                        number_of_fasta_fragments = 1;
                                                }
                                                else
                                                {
                                                        if (currentread.indexOf(">") == 0 || currentread.indexOf(">") == 1)
                                                        {
                                                                fasta_descriptors[number_of_fasta_fragments] = currentread;
                                                                ++number_of_fasta_fragments;
                                                        }
                                                        else if (currentread != null)
                                                        {
                                                                genome[(number_of_fasta_fragments - 1)] += currentread;
                                                        }
                                                        currentread = in.readLine();
                                                        if (currentread != null)
                                                                currentread = currentread.trim();
                                                }
                                        }
                                        while (currentread != null)
                                                ;
                                        if (this_is_a_fasta_file == false)
                                                genome[0] = genomebuff.toString();
                                        //----------  End moving nucleotides into string
                                        for (int fasta_fragments = 0; fasta_fragments < number_of_fasta_fragments; fasta_fragments++)
                                        {
                                                for (int n = 0; n < genome[fasta_fragments].length(); ++n)
                                                {
                                                        if (strandfiler_yes_or_no != 2)
                                                        {
                                                                for (int startfresh = 0; startfresh < number_of_sequence_fragments; startfresh++)
                                                                {
                                                                        current_positive_for_sequence_fragment[startfresh] = 0;

                                                                }
                                                                comparison = -1;
                                                                Leading_Strand_Loop:
                                                                for (int number_of_fragment = 0; number_of_fragment < number_of_sequence_fragments;
                                                                        ++number_of_fragment)
                                                                {
                                                                        if ((n + current_positive_for_sequence_fragment[inrefs[number_of_fragment]] +
                                                                                n_max[number_of_fragment] + fragment[number_of_fragment].length()) >
                                                                                genome[fasta_fragments].length())
                                                                                break Leading_Strand_Loop;
                                                                        comparison = run_the_comparision( genome[fasta_fragments].substring(
                                                                                (n + current_positive_for_sequence_fragment[inrefs[number_of_fragment]]
                                                                                + n_min[number_of_fragment]),
                                                                                (n + current_positive_for_sequence_fragment[inrefs[number_of_fragment]]
                                                                                + n_max[number_of_fragment] + fragment[number_of_fragment].length())),
                                                                                fragment[number_of_fragment], tol[number_of_fragment]);
                                                                        if (comparison == -1)
                                                                                break Leading_Strand_Loop;
                                                                        if (comparison >= 0)
                                                                        {
                                                                                current_positive_for_sequence_fragment[number_of_fragment] =
                                                                                        comparison + fragment[number_of_fragment].length() +
                                                                                        current_positive_for_sequence_fragment[ inrefs[number_of_fragment]];
                                                                                if (number_of_fragment == (number_of_sequence_fragments - 1))
                                                                                {
                                                                                        ++results;
                                                                                        gotresults = true;
                                                                                        iscomplementstrand[found_fragment_number] = false;
                                                                                        resultantnums[found_fragment_number] = n + 1;
                                                                                        found_matching_sequence[found_fragment_number] =
                                                                                                genome[fasta_fragments].substring(n,
                                                                                                (n + return_largest_value(
                                                                                                current_positive_for_sequence_fragment))) + " ";
                                                                                        if (this_is_a_fasta_file == true)
                                                                                                found_matching_sequence[found_fragment_number] +=
                                                                                                        "("+fasta_descriptors[fasta_fragments] + ") ";
                                                                                        ++found_fragment_number;

                                                                                }
                                                                        }
                                                                }
                                                                if (results >= 14999)
                                                                {
                                                                        found_matching_sequence[14999] += "\nMaximum of 15000 results, program halted.";
                                                                        break SearchLoop;
                                                                }

                                                        } //end of top strand
                                                        if (strandfiler_yes_or_no != 1)
                                                        {
                                                                for (int startfresh = 0; startfresh < number_of_sequence_fragments; startfresh++)
                                                                {
                                                                        current_positive_for_sequence_fragment[startfresh] = 0;
                                                                }
                                                                comparison = -1;
                                                                Complementary_Strand_Loop:
                                                                for (int number_of_fragment = 0; number_of_fragment < number_of_sequence_fragments;
                                                                        ++number_of_fragment)
                                                                {
                                                                        if ((n - (current_positive_for_sequence_fragment[inrefs[number_of_fragment]] +
                                                                                n_max[number_of_fragment] + fragment[number_of_fragment].length())) < 0)
                                                                                break Complementary_Strand_Loop;
                                                                        comparison = run_the_comparision( generate_reverse_complement(
                                                                                genome[fasta_fragments].substring(
                                                                                (n - (current_positive_for_sequence_fragment[inrefs[number_of_fragment]]
                                                                                + n_max[number_of_fragment] + fragment[number_of_fragment].length())),
                                                                                (n - (current_positive_for_sequence_fragment[inrefs[number_of_fragment]]
                                                                                + n_min[number_of_fragment])))), fragment[number_of_fragment],
                                                                                tol[number_of_fragment]);
                                                                        if (comparison == -1)
                                                                                break Complementary_Strand_Loop;
                                                                        if (comparison >= 0)
                                                                        {
                                                                                current_positive_for_sequence_fragment[number_of_fragment] =
                                                                                        comparison + fragment[number_of_fragment].length() +
                                                                                        current_positive_for_sequence_fragment[ inrefs[number_of_fragment]];
                                                                                if (number_of_fragment == (number_of_sequence_fragments - 1))
                                                                                {
                                                                                        ++results;
                                                                                        gotresults = true;
                                                                                        iscomplementstrand[found_fragment_number] = true;
                                                                                        resultantnums[found_fragment_number] = n + 1;
                                                                                        found_matching_sequence[found_fragment_number] =
                                                                                                generate_reverse_complement(
                                                                                                genome[fasta_fragments].substring(
                                                                                                (n - return_largest_value(
                                                                                                current_positive_for_sequence_fragment)), n)) + " ";
                                                                                        if (this_is_a_fasta_file == true)
                                                                                                found_matching_sequence[found_fragment_number] +=
                                                                                                        "("+fasta_descriptors[fasta_fragments] + ") ";
                                                                                        ++found_fragment_number;

                                                                                }
                                                                        }
                                                                }
                                                                if (results >= 14999)
                                                                {
                                                                        found_matching_sequence[14999] += "\nMaximum of 15000 results, program halted.";
                                                                        break SearchLoop;
                                                                }
                                                        }
                                                } // end of (n)
                                        } // end of fasta_fragments
                                        hitsfound.setText("Hits found: "+ results);
                                        filescompleted.setText("Search Progress: "+ current_file + "/"+ number_of_files_to_search);
                                        Rectangle hitsrect = hitsfound.getBounds();
                                        hitsrect.x = 0;
                                        hitsrect.y = 0;
                                        hitsfound.paintImmediately(hitsrect);
                                        Rectangle filesrect = filescompleted.getBounds();
                                        filesrect.x = 0;
                                        hitsrect.y = 0;
                                        filescompleted.paintImmediately(filesrect);
                                        progress.setValue(number_of_files_to_search);
                                        Rectangle progressrect = progress.getBounds();
                                        progressrect.x = 0;
                                        progressrect.y = 0;
                                        progress.paintImmediately(progressrect);

                                        //--------------    Parsing subroutine
                                        if (found_fragment_number > 0)
                                        {
                                                // output
                                                if (shouldparse == false)
                                                {
                                                        for (int parse_counter = 0; parse_counter < found_fragment_number; ++parse_counter)
                                                        {
                                                                if (searchtype == 2)
                                                                        found_matching_sequence[parse_counter] +=
                                                                                gi_descriptor[current_file] + " {"+ resultantnums[parse_counter] + "}:";
                                                                else if (searchtype == 1 && this_is_a_fasta_file == false)
                                                                        found_matching_sequence[parse_counter] +=
                                                                                templatefiles[current_file].getName() + " {"+
                                                                                resultantnums[parse_counter] + "}:";
                                                                if (iscomplementstrand[parse_counter] == true)
                                                                        found_matching_sequence[parse_counter] += "[C]";

                                                        }
                                                }
                                                else
                                                {
                                                        String[] GPresults;
                                                        GPsub = new GeneParse(geneinfo, found_fragment_number, resultantnums, iscomplementstrand, "");
                                                        GPresults = GPsub.parsingresults;
                                                        for (int parse_counter = 0; parse_counter < found_fragment_number; ++parse_counter)
                                                        {
                                                                if (iscomplementstrand[parse_counter] == true)
                                                                        found_matching_sequence[parse_counter] += "[C]";
                                                                if (searchtype == 2)
                                                                        found_matching_sequence[parse_counter] +=
                                                                                parse_counter + ". "+gi_descriptor[current_file] + " {"+
                                                                                resultantnums[parse_counter] + "}:";
                                                                else
                                                                        found_matching_sequence[parse_counter] +=
                                                                                parse_counter + ". "+ templatefiles[current_file].getName() + " {"+
                                                                                resultantnums[parse_counter] + "}:";

                                                                // ----- Add in Extragenic/Intragenic or intra-intron discovery from the GeneParse routine (stored in GPsub)
                                                                found_matching_sequence[parse_counter] += GPresults[parse_counter];
                                                                // ----- End
                                                        }
                                                }
                                                //--------------format by adding /n to the end of each string and count the total found
                                                for (int format_counter = 0; format_counter < found_fragment_number ; ++format_counter)
                                                {
                                                        resultstrings[totalnum] = found_matching_sequence[format_counter] + "\n";
                                                        ++totalnum;
                                                }
                                                //-------------- end format counter
                                        }
                                        in.close();
                                } //end of 430

                                this.dispose();
                        }//end try

                        catch (MalformedURLException e)
                        {
                                System.out.println("Can not connect to datafiles.");
                        }

                        catch (IOException e)
                        {
                                haderrors = true;
                                System.out.println("IO Error.");

                        }
        }

        public static int run_the_comparision(String intemplate, String inquery, int tolerance)
        {
                int allowed_error = tolerance;
                int goback = -1;
                int template_length = 0;
                int query_length = 0;
                char[] template = intemplate.toCharArray();
                char[] query = inquery.toCharArray();
                template_length = template.length;
                query_length = query.length;
                JLoop:
                for (int j = 0; j <= (template_length - query_length); j++)
                {
                        int accuracy = 0;
                        KLoop:
                        for (int k = 0; k < query_length; k++)
                        {
                                switch (query[k])
                                {

                                case 'n':

                                case 'N':

                                        if (template[(j + k)] != 'n')
                                                ++accuracy;

                                        break;

                                case 'a':

                                case 'A':

                                        if (template[(j + k)] == 'a' || template[(j + k)] == 'A')
                                                ++accuracy;

                                        break;

                                case 'c':

                                case 'C':

                                        if (template[(j + k)] == 'c' || template[(j + k)] == 'C')
                                                ++accuracy;

                                        break;

                                case 't':

                                case 'T':

                                        if (template[(j + k)] == 't' || template[(j + k)] == 'T')
                                                ++accuracy;

                                        break;

                                case 'g':

                                case 'G':

                                        if (template[(j + k)] == 'g' || template[(j + k)] == 'G')
                                                ++accuracy;

                                        break;

                                case 'k':

                                case 'K':

                                        if (template[(j + k)] == 't' || template[(j + k)] == 'T' || template[(j + k)] == 'g' || template[(j + k)] == 'G')
                                                ++accuracy;

                                        break;

                                case 'M':

                                case 'm':

                                        if (template[(j + k)] == 'c' || template[(j + k)] == 'C' || template[(j + k)] == 'a' || template[(j + k)] == 'A')
                                                ++accuracy;

                                        break;

                                case 'Y':

                                case 'y':

                                        if (template[(j + k)] == 't' || template[(j + k)] == 'T' || template[(j + k)] == 'c' || template[(j + k)] == 'C')
                                                ++accuracy;

                                        break;

                                case 'W':

                                case 'w':

                                        if (template[(j + k)] == 't' || template[(j + k)] == 'T' || template[(j + k)] == 'A' || template[(j + k)] == 'a')
                                                ++accuracy;

                                        break;

                                case 'S':

                                case 's':

                                        if (template[(j + k)] == 'g' || template[(j + k)] == 'G' || template[(j + k)] == 'c' || template[(j + k)] == 'C')
                                                ++accuracy;

                                        break;

                                case 'R':

                                case 'r':

                                        if (template[(j + k)] == 'a' || template[(j + k)] == 'A' || template[(j + k)] == 'g' || template[(j + k)] == 'G')
                                                ++accuracy;
                                        break;

                                case 'B':

                                case 'b':

                                        if (template[(j + k)] == 'g' || template[(j + k)] == 'G' || template[(j + k)] == 'c' ||
                                                template[(j + k)] == 'C' || template[(j + k)] == 't' || template[(j + k)] == 'T')
                                                ++accuracy;

                                        break;

                                case 'H':

                                case 'h':

                                        if (template[(j + k)] == 'a' || template[(j + k)] == 'A' || template[(j + k)] == 'c' ||
                                                template[(j + k)] == 'C' || template[(j + k)] == 'T' || template[(j + k)] == 't')
                                                ++accuracy;

                                        break;

                                case 'D':

                                case 'd':

                                        if (template[(j + k)] == 'a' || template[(j + k)] == 'A' || template[(j + k)] == 'g' ||
                                                template[(j + k)] == 'G' || template[(j + k)] == 't' || template[(j + k)] == 'T')
                                                ++accuracy;

                                        break;

                                case 'V':

                                case 'v':

                                        if (template[(j + k)] == 'a' || template[(j + k)] == 'A' || template[(j + k)] == 'c' ||
                                                template[(j + k)] == 'C' || template[(j + k)] == 'g' || template[(j + k)] == 'G')
                                                ++accuracy;

                                        break;

                                }
                                ////System.out.println("j="+j+" k="+k+" accuracy="+accuracy+" tolerance ="+tolerance);
                                if (((k + 1) - accuracy) > allowed_error)
                                {
                                        ////System.out.println("Broke K Loop");
                                        break KLoop;
                                }
                        }

                        if (accuracy >= (query_length - allowed_error))
                        {
                                //System.out.println("Match.");
                                goback = j;
                                return goback;
                                // break JLoop;
                        }
                }
                goback = -1;
                return goback;
        }

        public static int return_largest_value(int[] incoming_array)
                        {
                                int number_to_be_sent_back = 0;
                        for (int w = 0; w < incoming_array.length; ++w)
                                {
                                if (incoming_array[w] > number_to_be_sent_back)
                                                number_to_be_sent_back = incoming_array[w];
                                }
                                return number_to_be_sent_back;
                        }


                public static String generate_reverse_complement(String incoming_template)
                        {
                                char[] tempchar = incoming_template.toCharArray();
                                String send_back_rc = "";
                        for (int w = ((tempchar.length) - 1); w >= 0; --w)
                                {
                                switch (tempchar[w])
                                        {
                                case 'a':
                                case 'A':
                                                tempchar[w] = 't';
                                                break;
                                case 't':
                                case 'T':
                                                tempchar[w] = 'a';
                                                break;
                                case 'c':
                                case 'C':
                                                tempchar[w] = 'g';
                                                break;
                                case 'g':
                                case 'G':
                                                tempchar[w] = 'c';
                                                break;
                                case 'm':
                                case 'M':
                                                tempchar[w] = 'k';
                                                break;
                                case 'K':
                                case 'k':
                                                tempchar[w] = 'm';
                                                break;
                                case 'R':
                                case 'r':
                                                tempchar[w] = 'y';
                                                break;
                                case 'Y':
                                case 'y':
                                                tempchar[w] = 'r';
                                                break;
                                case 'V':
                                case 'v':
                                                tempchar[w] = 'b';
                                                break;
                                case 'B':
                                case 'b':
                                                tempchar[w] = 'v';
                                                break;
                                case 'H':
                                case 'h':
                                                tempchar[w] = 'd';
                                                break;
                                case 'D':
                                case 'd':
                                                tempchar[w] = 'h';
                                                break;
                                case 'n':
                                case 'N':
                                                tempchar[w] = 'n';
                                                break;
                                        }
                                        send_back_rc += tempchar[w];
                                }
                                return send_back_rc;
                        }


                }