//Part of the JDSA Program.  Tom Boulay, Kadonaga Lab, All Rights Reserved (2004).  
//While no known computer problems have occured as a result of using the JDSA, users assume all risk in using the JDSA.
//Please cite CY Lim et al (2004) if you use the JDSA

import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

class JDSA_TopLevel_Framework extends JFrame implements ActionListener
{
        private JPanel bottompanel;
        private JScrollPane listscroll;
        private JMenuBar Newmenubar;
        private JMenu Newmenu;
        private JMenuItem NewSearch;
        private JMenu Sourcemenu;
        public JTextArea outputlist;
        public int seqfrags;
        public boolean proceedon = false;
        public JDSASearch JDSA;
        public Query_Input_Dialog Active_Input_Dialog;
        public File[] files_that_get_searched;
        int number_of_fragments = 0;
        public int type_of_search = 0; //0 is invalid, 1 is local, 2 is internet
        public BufferedReader customin;

        public JDSA_TopLevel_Framework()
        {
                setTitle("JDSA (Java Degenerate Search Algorthm) v.1 -=- Tom Boulay, Kadonaga Lab 2003, All rights reserved");
                setSize(750, 300);
                bottompanel = new JPanel();
                bottompanel.setLayout(new BorderLayout());
                getContentPane().add(bottompanel);
                outputlist = new JTextArea("");
                listscroll = new JScrollPane();
                listscroll.getViewport().add(outputlist);
                bottompanel.add(listscroll, BorderLayout.CENTER);
                //------------- Bottom Window
                Newmenubar = new JMenuBar();
                setJMenuBar(Newmenubar);
                Newmenu = new JMenu("New");
                Newmenubar.add(Newmenu);
                NewSearch = new JMenuItem();
                NewSearch.setText("New Search...");
                NewSearch.addActionListener(this);
                NewSearch.setEnabled(true);
                Newmenu.add(NewSearch);
                

                this.addWindowListener(new WindowAdapter()
                                       {
                                               public void windowClosing(WindowEvent e)
                                               {
                                                       System.exit(0);
                                               }
                                       }
                                      );
        }
        public void actionPerformed(ActionEvent event)
        {
                if (event.getSource() == NewSearch)
                {
                        JOptionPane panehowmanyfrags = new JOptionPane();
                        Object[] possibleValues = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10" };
                        Object selectedValue = panehowmanyfrags.showInputDialog(this, "How many fragments? (Zero will abort new search)", "Question",
                                JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[0]);
                        proceedon = false;
                        if (selectedValue == "0")
                        {
                                proceedon = false;
                                number_of_fragments = 0;

                        }
                        else
                        {
                                proceedon = true;
                                if (selectedValue == "1")
                                        number_of_fragments = 1;
                                else if (selectedValue == "2")
                                        number_of_fragments = 2;
                                else if (selectedValue == "3")
                                        number_of_fragments = 3;
                                else if (selectedValue == "4")
                                        number_of_fragments = 4;
                                else if (selectedValue == "5")
                                        number_of_fragments = 5;
                                else if (selectedValue == "6")
                                        number_of_fragments = 6;
                                else if (selectedValue == "7")
                                        number_of_fragments = 7;
                                else if (selectedValue == "8")
                                        number_of_fragments = 8;
                                else if (selectedValue == "9")
                                        number_of_fragments = 9;
                                else if (selectedValue == "10")
                                        number_of_fragments = 10;
                                else
                                        proceedon = false;
                        }
                        if (proceedon == true)
                        {
                                Active_Input_Dialog = new Query_Input_Dialog(this, number_of_fragments, files_that_get_searched, type_of_search);
                                Active_Input_Dialog.pack();
                                Active_Input_Dialog.setModal(true);
                                Active_Input_Dialog.setVisible(true);
                                if (Active_Input_Dialog.datagathered == true)
                                {
                                        files_that_get_searched = Active_Input_Dialog.files_to_search;
                                        type_of_search = Active_Input_Dialog.searchtype;
                                        JDSASearch JDSA = new JDSASearch(this, Active_Input_Dialog.shouldparse, number_of_fragments,
                                                Active_Input_Dialog.sequence_fragment, Active_Input_Dialog.mismatch, Active_Input_Dialog.mindist,
                                                Active_Input_Dialog.maxdist, Active_Input_Dialog.searchtype, Active_Input_Dialog.relative_to_which_fragment, Active_Input_Dialog.files_to_search, Active_Input_Dialog.strandfilt);
                                        JDSA.setModal(true);
                                        JDSA.pack();
                                        JDSA.setVisible(true);
                                        if (JDSA.gotresults == true && JDSA.haderrors == false)
                                        {
                                                int rn = 0;
                                                AddLoop:
                                                for (int parsing_sequence_loop_counter = 0; parsing_sequence_loop_counter < JDSA.totalnum;
                                                        ++parsing_sequence_loop_counter)
                                                {
                                                        if (Active_Input_Dialog.strandfilt >= 1)
                                                        {
                                                                if (Active_Input_Dialog.shouldparse == true && Active_Input_Dialog.strandfilt == 1 &&
                                                                        JDSA.resultstrings[parsing_sequence_loop_counter].indexOf("complement") >= 0)
                                                                        continue AddLoop;
                                                                if (Active_Input_Dialog.shouldparse == false && Active_Input_Dialog.strandfilt == 1 &&
                                                                        JDSA.resultstrings[parsing_sequence_loop_counter].indexOf("[C]") >= 0)
                                                                        continue AddLoop;
                                                                if (Active_Input_Dialog.shouldparse == true && Active_Input_Dialog.strandfilt == 2 &&
                                                                        JDSA.resultstrings[parsing_sequence_loop_counter].indexOf("complement") == -1)
                                                                        continue AddLoop;
                                                                if (Active_Input_Dialog.shouldparse == false && Active_Input_Dialog.strandfilt == 2 &&
                                                                        JDSA.resultstrings[parsing_sequence_loop_counter].indexOf("[C]") == -1)
                                                                        continue AddLoop;
                                                        }
                                                        if (Active_Input_Dialog.shouldparse == true && Active_Input_Dialog.parsefilt != 0)
                                                        {
                                                                if (Active_Input_Dialog.parsefilt == 1 &&
                                                                        JDSA.resultstrings[parsing_sequence_loop_counter].indexOf("Extragenic") == -1)
                                                                        continue AddLoop;
                                                                if (Active_Input_Dialog.parsefilt == 2 &&
                                                                        JDSA.resultstrings[parsing_sequence_loop_counter].indexOf("ORF") == -1)
                                                                        continue AddLoop;
                                                                if (Active_Input_Dialog.parsefilt == 3 &&
                                                                        JDSA.resultstrings[parsing_sequence_loop_counter].indexOf("Intron") == -1)
                                                                        continue AddLoop;
                                                                if (Active_Input_Dialog.parsefilt == 4 &&
                                                                        (JDSA.resultstrings[parsing_sequence_loop_counter].indexOf("Extragenic") ==
                                                                        -1) && (JDSA.resultstrings[parsing_sequence_loop_counter].indexOf("Intron") == -1))
                                                                        continue AddLoop;
                                                        }
                                                        ++rn;
                                                        outputlist.append("\n");
                                                        outputlist.append(rn + ". "+JDSA.resultstrings[parsing_sequence_loop_counter]);
                                                }
                                        }
                                        else if (JDSA.gotresults == false && JDSA.haderrors == false)
                                                outputlist.append("\nNo results.\n");
                                }
                        }
                }
        }


        public static void main(String args[])
        {
                JDSA_TopLevel_Framework JDSA_window = new JDSA_TopLevel_Framework();
                JDSA_window.setVisible(true);
        }

 }
