//Part of the JDSA Program.  Tom Boulay, Kadonaga Lab, All Rights Reserved (2004).  
//While no known computer problems have occured as a result of using the JDSA, users assume all risk in using the JDSA.
//Please cite CY Lim et al (2004) if you use the JDSA

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

class Query_Input_Dialog extends JDialog implements ActionListener
{
        private JFrame parentFrame;
        private JScrollPane scrollpane;
        public String[] sequence_fragment = {"","","","","","","","","",""};
        public int[] mismatch = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        public int[] maxdist = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        public int[] mindist = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        public int searchtype = 0; //0 is invalid, 1 is local file(s), 2 is local file pointing to NCBI files
        public JTextField sequence_textfield_10, sequence_textfield_1, sequence_textfield_2, sequence_textfield_3, sequence_textfield_4,
        sequence_textfield_5, sequence_textfield_6, sequence_textfield_7, sequence_textfield_8, sequence_textfield_9;
        private JTextField mismatchinput_1, mismatchinput_2, mismatchinput_3, mismatchinput_4, mismatchinput_5, mismatchinput_6, mismatchinput_7,
        mismatchinput_8, mismatchinput_9, mismatchinput_10;
        private JTextField mindistinput_1, mindistinput_2, mindistinput_3, mindistinput_4, mindistinput_5, mindistinput_6, mindistinput_7,
        mindistinput_8, mindistinput_9, mindistinput_10;
        private JTextField maxdistinput_1, maxdistinput_2, maxdistinput_3, maxdistinput_4, maxdistinput_5, maxdistinput_6, maxdistinput_7,
        maxdistinput_8, maxdistinput_9, maxdistinput_10;
        public boolean datagathered = false;
        private JPanel datapanel_1, datapanel_2, datapanel_3, datapanel_4, datapanel_5, datapanel_6, datapanel_7, datapanel_8, datapanel_9, datapanel_10;
        private JButton okbutton, cancelbutton, infobutton, change_file_to_be_searched;
        private Document document_sequence_textfield_1, document_sequence_textfield_2, document_sequence_textfield_3, document_sequence_textfield_4,
        document_sequence_textfield_5, document_sequence_textfield_6, document_sequence_textfield_7, document_sequence_textfield_8,
        document_sequence_textfield_9, document_sequence_textfield_10, document_maximum_mismatch_1, document_maximum_mismatch_2,
        document_maximum_mismatch_3, document_maximum_mismatch_4, document_maximum_mismatch_5, document_maximum_mismatch_6,
        document_maximum_mismatch_7, document_maximum_mismatch_8, document_maximum_mismatch_9, document_maximum_mismatch_10,
        document_minimum_allowed_spacing_1, document_minimum_allowed_spacing_2, document_minimum_allowed_spacing_3,
        document_minimum_allowed_spacing_4, document_minimum_allowed_spacing_5, document_minimum_allowed_spacing_6,
        document_minimum_allowed_spacing_7, document_minimum_allowed_spacing_8, document_minimum_allowed_spacing_9,
        document_minimum_allowed_spacing_10, document_maximum_allowed_spacing_1, document_maximum_allowed_spacing_2,
        document_maximum_allowed_spacing_3, document_maximum_allowed_spacing_4, document_maximum_allowed_spacing_5,
        document_maximum_allowed_spacing_6, document_maximum_allowed_spacing_7, document_maximum_allowed_spacing_8,
        document_maximum_allowed_spacing_9, document_maximum_allowed_spacing_10;
        public int numiterations = 0;
        public JComboBox parsefilter, strandfilter, ref3, ref4, ref5, ref6, ref7, ref8, ref9, ref10, liststats;
        public JCheckBox should_results_be_parsed;
        public boolean shouldparse = false;
        public int selfile = -1;
        public int[] relative_to_which_fragment = {0, 0, 1, 2, 3, 4, 5, 6, 7, 8};
        public int strandfilt = 0;
        public int parsefilt = 0;
        public int liststatnum = 0;
        public Chart achart;
        public boolean have_file_path = false;
        public JLabel pathlabel;
        String parsechange = "parsechange";
        public File[] files_to_search;

        public Query_Input_Dialog(JFrame parentFrame, int iterations, File[] from_toplevel_files_to_search, int incoming_searchtype)
        {
                super(parentFrame);
                this.parentFrame = parentFrame;
                numiterations = iterations;
                if (numiterations <= 0 || numiterations >= 11)
                        this.dispose();
                setTitle("JDSA Fragments Input");
                int a = 0;
                if (iterations % 2 != 0)
                        a = (iterations / 2) + 1;
                else
                        a = iterations / 2;
                setSize(750, (a * 130 + 250));
                numiterations = iterations;
                files_to_search = from_toplevel_files_to_search;
                searchtype = incoming_searchtype;
                if (files_to_search != null && files_to_search.length > 0)
                        have_file_path = true;
                setDefaultCloseOperation(DISPOSE_ON_CLOSE);
                JPanel bottomdialogpanel = new JPanel();
                bottomdialogpanel.setLayout(new BorderLayout());
                getContentPane().add(bottomdialogpanel);
                scrollpane = new JScrollPane();
                bottomdialogpanel.add(scrollpane, BorderLayout.CENTER);
                JPanel topsection = new JPanel();
                JPanel bottomsection = new JPanel();
                bottomsection.setPreferredSize(new Dimension(700, 100));
                JPanel combosection = new JPanel();
                bottomsection.setLayout(new GridLayout(1,2));
                topsection.setLayout(new GridLayout(a, 2));
                combosection.setLayout(new BoxLayout(combosection, BoxLayout.Y_AXIS));
                combosection.add(topsection);
                combosection.add(bottomsection);
                scrollpane.getViewport().add(combosection);
                if (iterations > 0)
                {
                        JPanel datapanel_1 = new JPanel();
                        datapanel_1.setLayout(new FlowLayout());
                        datapanel_1.setPreferredSize(new Dimension(310, 130));
                        datapanel_1.setBorder(new BevelBorder(BevelBorder.RAISED));
                        sequence_textfield_1 = new JTextField(10);
                        document_sequence_textfield_1 = sequence_textfield_1.getDocument();
                        JLabel label = new JLabel("Sequence Fragment #1: ");
                        label.setLabelFor(sequence_textfield_1);
                        mismatchinput_1 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_1);
                        document_maximum_mismatch_1 = mismatchinput_1.getDocument();
                        datapanel_1.add(label);
                        datapanel_1.add(sequence_textfield_1);
                        datapanel_1.add(label2);
                        datapanel_1.add(mismatchinput_1);
                        topsection.add(datapanel_1);
                        document_sequence_textfield_1.addDocumentListener(new DocumentHandler());
                        document_maximum_mismatch_1.addDocumentListener(new DocumentHandler());
                }
                if (iterations > 1)
                {
                        JPanel datapanel_2 = new JPanel();
                        datapanel_2.setPreferredSize(new Dimension(310, 130));
                        datapanel_2.setBorder(new BevelBorder(BevelBorder.RAISED));
                        datapanel_2.setLayout(new FlowLayout());
                        sequence_textfield_2 = new JTextField(10);
                        JLabel label = new JLabel("Sequence Fragment #2: ");
                        label.setLabelFor(sequence_textfield_2);
                        mismatchinput_2 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_2);
                        topsection.add(datapanel_2);
                        datapanel_2.add(label);
                        datapanel_2.add(sequence_textfield_2);
                        datapanel_2.add(label2);
                        datapanel_2.add(mismatchinput_2);
                        mindistinput_2 = new JTextField("0",2);
                        JLabel label3 = new JLabel("Minimum Distance from the end of fragment #1: ");
                        label3.setLabelFor(mindistinput_2);
                        maxdistinput_2 = new JTextField("0",2);
                        JLabel label4 = new JLabel("Maximum Distance from the end of fragment #1: ");
                        datapanel_2.add(label3);
                        datapanel_2.add(mindistinput_2);
                        datapanel_2.add(label4);
                        datapanel_2.add(maxdistinput_2);
                        document_sequence_textfield_2 = sequence_textfield_2.getDocument();
                        document_minimum_allowed_spacing_2 = mindistinput_2.getDocument();
                        document_maximum_allowed_spacing_2 = maxdistinput_2.getDocument();
                        document_maximum_mismatch_2 = mismatchinput_2.getDocument();
                        document_sequence_textfield_2.addDocumentListener(new DocumentHandler());
                        document_maximum_mismatch_2.addDocumentListener(new DocumentHandler());
                        document_minimum_allowed_spacing_2.addDocumentListener(new DocumentHandler());
                        document_maximum_allowed_spacing_2.addDocumentListener(new DocumentHandler());

                }
                if (iterations > 2)
                {
                        JPanel datapanel_3 = new JPanel();
                        datapanel_3.setPreferredSize(new Dimension(310, 130));
                        datapanel_3.setBorder(new BevelBorder(BevelBorder.RAISED));
                        datapanel_3.setLayout(new GridLayout(5, 2));
                        sequence_textfield_3 = new JTextField(10);
                        JLabel label = new JLabel("Sequence Fragment #3: ");
                        label.setLabelFor(sequence_textfield_3);
                        mismatchinput_3 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_3);
                        topsection.add(datapanel_3);
                        sequence_textfield_3.setSize(100, 50);
                        datapanel_3.add(label);
                        datapanel_3.add(sequence_textfield_3);
                        datapanel_3.add(label2);
                        datapanel_3.add(mismatchinput_3);
                        JLabel rlabel = new JLabel("Reference Fragment: ", SwingConstants.LEFT);
                        ref3 = new JComboBox();
                        for (int buildref = 1; buildref <= 2; buildref++)
                                ref3.addItem(" "+buildref);
                        ref3.setSelectedIndex(1);
                        rlabel.setLabelFor(ref3);
                        datapanel_3.add(rlabel);
                        datapanel_3.add(ref3);
                        mindistinput_3 = new JTextField("0",2);
                        JLabel label3 = new JLabel("Min Dist from end of RF:");
                        label3.setLabelFor(mindistinput_3);
                        maxdistinput_3 = new JTextField("0",2);
                        JLabel label4 = new JLabel("Max Dist from end of RF:");
                        datapanel_3.add(label3);
                        datapanel_3.add(mindistinput_3);
                        datapanel_3.add(label4);
                        datapanel_3.add(maxdistinput_3);
                        document_sequence_textfield_3 = sequence_textfield_3.getDocument();
                        document_minimum_allowed_spacing_3 = mindistinput_3.getDocument();
                        document_maximum_allowed_spacing_3 = maxdistinput_3.getDocument();
                        document_maximum_mismatch_3 = mismatchinput_3.getDocument();
                        document_sequence_textfield_3.addDocumentListener(new DocumentHandler());
                        document_maximum_mismatch_3.addDocumentListener(new DocumentHandler());
                        document_minimum_allowed_spacing_3.addDocumentListener(new DocumentHandler());
                        document_maximum_allowed_spacing_3.addDocumentListener(new DocumentHandler());;

                }
                if (iterations > 3)
                {
                        JPanel datapanel_4 = new JPanel();
                        datapanel_4.setPreferredSize(new Dimension(310, 130));
                        datapanel_4.setBorder(new BevelBorder(BevelBorder.RAISED));
                        datapanel_4.setLayout(new GridLayout(5, 2));
                        sequence_textfield_4 = new JTextField(10);
                        JLabel label = new JLabel("Sequence Fragment #4: ");
                        label.setLabelFor(sequence_textfield_4);
                        mismatchinput_4 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_4);
                        topsection.add(datapanel_4);
                        datapanel_4.add(label);
                        datapanel_4.add(sequence_textfield_4);
                        datapanel_4.add(label2);
                        datapanel_4.add(mismatchinput_4);
                        JLabel rlabel = new JLabel("Reference Fragment: ");
                        ref4 = new JComboBox();
                        for (int buildref = 1; buildref <= 3; buildref++)
                                ref4.addItem(" "+buildref);
                        ref4.setSelectedIndex(2);
                        rlabel.setLabelFor(ref4);
                        datapanel_4.add(rlabel);
                        datapanel_4.add(ref4);
                        mindistinput_4 = new JTextField("0",2);
                        JLabel label3 = new JLabel("Min Dist from end of RF:");
                        label3.setLabelFor(mindistinput_4);
                        maxdistinput_4 = new JTextField("0",2);
                        JLabel label4 = new JLabel("Max Dist from end of RF:");
                        datapanel_4.add(label3);
                        datapanel_4.add(mindistinput_4);
                        datapanel_4.add(label4);
                        datapanel_4.add(maxdistinput_4);
                        document_sequence_textfield_4 = sequence_textfield_4.getDocument();
                        document_minimum_allowed_spacing_4 = mindistinput_4.getDocument();
                        document_maximum_allowed_spacing_4 = maxdistinput_4.getDocument();
                        document_maximum_mismatch_4 = mismatchinput_4.getDocument();
                        document_sequence_textfield_4.addDocumentListener(new DocumentHandler());
                        document_maximum_mismatch_4.addDocumentListener(new DocumentHandler());
                        document_minimum_allowed_spacing_4.addDocumentListener(new DocumentHandler());
                        document_maximum_allowed_spacing_4.addDocumentListener(new DocumentHandler());

                }
                if (iterations > 4)
                {
                        JPanel datapanel_5 = new JPanel();
                        datapanel_5.setPreferredSize(new Dimension(310, 130));
                        datapanel_5.setBorder(new BevelBorder(BevelBorder.RAISED));
                        datapanel_5.setLayout(new GridLayout(5, 2));
                        sequence_textfield_5 = new JTextField(10);
                        JLabel label = new JLabel("Sequence Fragment #5: ");
                        label.setLabelFor(sequence_textfield_5);
                        mismatchinput_5 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_5);
                        topsection.add(datapanel_5);
                        datapanel_5.add(label);
                        datapanel_5.add(sequence_textfield_5);
                        datapanel_5.add(label2);
                        datapanel_5.add(mismatchinput_5);
                        JLabel rlabel = new JLabel("Reference Fragment: ");
                        ref5 = new JComboBox();
                        for (int buildref = 1; buildref <= 4; buildref++)
                                ref5.addItem(" "+buildref);
                        ref5.setSelectedIndex(3);
                        rlabel.setLabelFor(ref5);
                        datapanel_5.add(rlabel);
                        datapanel_5.add(ref5);
                        mindistinput_5 = new JTextField("0",2);
                        JLabel label3 = new JLabel("Min Dist from end of RF:");
                        label3.setLabelFor(mindistinput_5);
                        maxdistinput_5 = new JTextField("0",2);
                        JLabel label4 = new JLabel("Max Dist from end of RF:");
                        datapanel_5.add(label3);
                        datapanel_5.add(mindistinput_5);
                        datapanel_5.add(label4);
                        datapanel_5.add(maxdistinput_5);
                        document_sequence_textfield_5 = sequence_textfield_5.getDocument();
                        document_minimum_allowed_spacing_5 = mindistinput_5.getDocument();
                        document_maximum_allowed_spacing_5 = maxdistinput_5.getDocument();
                        document_maximum_mismatch_5 = mismatchinput_5.getDocument();
                        document_sequence_textfield_5.addDocumentListener(new DocumentHandler());
                        document_maximum_mismatch_5.addDocumentListener(new DocumentHandler());
                        document_minimum_allowed_spacing_5.addDocumentListener(new DocumentHandler());
                        document_maximum_allowed_spacing_5.addDocumentListener(new DocumentHandler());

                }
                if (iterations > 5)
                {
                        JPanel datapanel_6 = new JPanel();
                        datapanel_6.setPreferredSize(new Dimension(310, 130));
                        datapanel_6.setBorder(new BevelBorder(BevelBorder.RAISED));
                        datapanel_6.setLayout(new GridLayout(5, 2));
                        sequence_textfield_6 = new JTextField(10);
                        JLabel label = new JLabel("Sequence Fragment #6: ");
                        label.setLabelFor(sequence_textfield_6);
                        mismatchinput_6 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_6);
                        topsection.add(datapanel_6);
                        datapanel_6.add(label);
                        datapanel_6.add(sequence_textfield_6);
                        datapanel_6.add(label2);
                        datapanel_6.add(mismatchinput_6);
                        JLabel rlabel = new JLabel("Reference Fragment: ");
                        ref6 = new JComboBox();
                        for (int buildref = 1; buildref <= 5; buildref++)
                                ref6.addItem(" "+buildref);
                        ref6.setSelectedIndex(4);
                        rlabel.setLabelFor(ref6);
                        datapanel_6.add(rlabel);
                        datapanel_6.add(ref6);
                        mindistinput_6 = new JTextField("0",2);
                        JLabel label3 = new JLabel("Min Dist from end of RF:");
                        label3.setLabelFor(mindistinput_6);
                        maxdistinput_6 = new JTextField("0",2);
                        JLabel label4 = new JLabel("Max Dist from end of RF:");
                        datapanel_6.add(label3);
                        datapanel_6.add(mindistinput_6);
                        datapanel_6.add(label4);
                        datapanel_6.add(maxdistinput_6);
                        document_sequence_textfield_6 = sequence_textfield_6.getDocument();
                        document_minimum_allowed_spacing_6 = mindistinput_6.getDocument();
                        document_maximum_allowed_spacing_6 = maxdistinput_6.getDocument();
                        document_maximum_mismatch_6 = mismatchinput_6.getDocument();
                        document_maximum_mismatch_6.addDocumentListener(new DocumentHandler());
                        document_minimum_allowed_spacing_6.addDocumentListener(new DocumentHandler());
                        document_maximum_allowed_spacing_6.addDocumentListener(new DocumentHandler());

                }
                if (iterations > 6)
                {
                        JPanel datapanel_7 = new JPanel();
                        datapanel_7.setPreferredSize(new Dimension(310, 130));
                        datapanel_7.setBorder(new BevelBorder(BevelBorder.RAISED));
                        datapanel_7.setLayout(new GridLayout(5, 2));
                        sequence_textfield_7 = new JTextField(10);
                        JLabel label = new JLabel("Sequence Fragment #7: ");
                        label.setLabelFor(sequence_textfield_7);
                        mismatchinput_7 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_7);
                        topsection.add(datapanel_7);
                        datapanel_7.add(label);
                        datapanel_7.add(sequence_textfield_7);
                        datapanel_7.add(label2);
                        datapanel_7.add(mismatchinput_7);
                        JLabel rlabel = new JLabel("Reference Fragment: ");
                        ref7 = new JComboBox();
                        for (int buildref = 1; buildref <= 6; buildref++)
                                ref7.addItem(" "+buildref);
                        ref7.setSelectedIndex(5);
                        rlabel.setLabelFor(ref7);
                        datapanel_7.add(rlabel);
                        datapanel_7.add(ref7);
                        mindistinput_7 = new JTextField("0",2);
                        JLabel label3 = new JLabel("Min Dist from end of RF:");
                        label3.setLabelFor(mindistinput_7);
                        maxdistinput_7 = new JTextField("0",2);
                        JLabel label4 = new JLabel("Max Dist from end of RF:");
                        datapanel_7.add(label3);
                        datapanel_7.add(mindistinput_7);
                        datapanel_7.add(label4);
                        datapanel_7.add(maxdistinput_7);
                        document_sequence_textfield_7 = sequence_textfield_7.getDocument();
                        document_minimum_allowed_spacing_7 = mindistinput_7.getDocument();
                        document_maximum_allowed_spacing_7 = maxdistinput_7.getDocument();
                        document_maximum_mismatch_7 = mismatchinput_7.getDocument();
                        document_sequence_textfield_7.addDocumentListener(new DocumentHandler());
                        document_maximum_mismatch_7.addDocumentListener(new DocumentHandler());
                        document_minimum_allowed_spacing_7.addDocumentListener(new DocumentHandler());
                        document_maximum_allowed_spacing_7.addDocumentListener(new DocumentHandler());

                }
                if (iterations > 7)
                {
                        JPanel datapanel_8 = new JPanel();
                        datapanel_8.setPreferredSize(new Dimension(310, 130));
                        datapanel_8.setBorder(new BevelBorder(BevelBorder.RAISED));
                        datapanel_8.setLayout(new GridLayout(5, 2));
                        sequence_textfield_8 = new JTextField(10);
                        JLabel label = new JLabel("Sequence Fragment #8: ");
                        label.setLabelFor(sequence_textfield_8);
                        mismatchinput_8 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_8);
                        topsection.add(datapanel_8);
                        datapanel_8.add(label);
                        datapanel_8.add(sequence_textfield_8);
                        datapanel_8.add(label2);
                        datapanel_8.add(mismatchinput_8);
                        JLabel rlabel = new JLabel("Reference Fragment: ");
                        ref8 = new JComboBox();
                        for (int buildref = 1; buildref <= 7; buildref++)
                                ref8.addItem(" "+buildref);
                        ref8.setSelectedIndex(6);
                        rlabel.setLabelFor(ref8);
                        datapanel_8.add(rlabel);
                        datapanel_8.add(ref8);
                        mindistinput_8 = new JTextField("0",2);
                        JLabel label3 = new JLabel("Min Dist from end of RF:");
                        label3.setLabelFor(mindistinput_8);
                        maxdistinput_8 = new JTextField("0",2);
                        JLabel label4 = new JLabel("Max Dist from end of RF:");
                        datapanel_8.add(label3);
                        datapanel_8.add(mindistinput_8);
                        datapanel_8.add(label4);
                        datapanel_8.add(maxdistinput_8);
                        document_sequence_textfield_8 = sequence_textfield_8.getDocument();
                        document_minimum_allowed_spacing_8 = mindistinput_8.getDocument();
                        document_maximum_allowed_spacing_8 = maxdistinput_8.getDocument();
                        document_maximum_mismatch_8 = mismatchinput_8.getDocument();
                        document_sequence_textfield_8.addDocumentListener(new DocumentHandler());
                        document_maximum_mismatch_8.addDocumentListener(new DocumentHandler());
                        document_minimum_allowed_spacing_8.addDocumentListener(new DocumentHandler());
                        document_maximum_allowed_spacing_8.addDocumentListener(new DocumentHandler());

                }
                if (iterations > 8)
                {
                        JPanel datapanel_9 = new JPanel();
                        datapanel_9.setPreferredSize(new Dimension(310, 130));
                        datapanel_9.setBorder(new BevelBorder(BevelBorder.RAISED));
                        datapanel_9.setLayout(new GridLayout(5, 2));
                        sequence_textfield_9 = new JTextField(10);
                        JLabel label = new JLabel("Sequence Fragment #9: ");
                        label.setLabelFor(sequence_textfield_9);
                        mismatchinput_9 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_9);
                        topsection.add(datapanel_9);
                        datapanel_9.add(label);
                        datapanel_9.add(sequence_textfield_9);
                        datapanel_9.add(label2);
                        datapanel_9.add(mismatchinput_9);
                        JLabel rlabel = new JLabel("Reference Fragment: ");
                        ref9 = new JComboBox();
                        for (int buildref = 1; buildref <= 8; buildref++)
                                ref9.addItem(" "+buildref);
                        ref9.setSelectedIndex(7);
                        rlabel.setLabelFor(ref9);
                        datapanel_9.add(rlabel);
                        datapanel_9.add(ref9);
                        mindistinput_9 = new JTextField("0",2);
                        JLabel label3 = new JLabel("Min Dist from end of RF:");
                        label3.setLabelFor(mindistinput_9);
                        maxdistinput_9 = new JTextField("0",2);
                        JLabel label4 = new JLabel("Max Dist from end of RF:");
                        datapanel_9.add(label3);
                        datapanel_9.add(mindistinput_9);
                        datapanel_9.add(label4);
                        datapanel_9.add(maxdistinput_9);
                        document_sequence_textfield_9 = sequence_textfield_9.getDocument();
                        document_minimum_allowed_spacing_9 = mindistinput_9.getDocument();
                        document_maximum_allowed_spacing_9 = maxdistinput_9.getDocument();
                        document_maximum_mismatch_9 = mismatchinput_9.getDocument();
                        document_sequence_textfield_9.addDocumentListener(new DocumentHandler());
                        document_maximum_mismatch_9.addDocumentListener(new DocumentHandler());
                        document_minimum_allowed_spacing_9.addDocumentListener(new DocumentHandler());
                        document_maximum_allowed_spacing_9.addDocumentListener(new DocumentHandler());

                }
                if (iterations > 9)
                {
                        JPanel datapanel_10 = new JPanel();
                        datapanel_10.setPreferredSize(new Dimension(310, 130));
                        datapanel_10.setBorder(new BevelBorder(BevelBorder.RAISED));
                        datapanel_10.setLayout(new GridLayout(5, 2));
                        sequence_textfield_10 = new JTextField(10);
                        JLabel label = new JLabel("Sequence Fragment #10: ");
                        label.setLabelFor(sequence_textfield_10);
                        mismatchinput_10 = new JTextField("0",2);
                        JLabel label2 = new JLabel("Maximum Allowed Mismatch: ");
                        label2.setLabelFor(mismatchinput_10);
                        topsection.add(datapanel_10);
                        datapanel_10.add(label);
                        datapanel_10.add(sequence_textfield_10);
                        datapanel_10.add(label2);
                        datapanel_10.add(mismatchinput_10);
                        JLabel rlabel = new JLabel("Reference Fragment: ");
                        ref10 = new JComboBox();
                        for (int buildref = 1; buildref <= 9; buildref++)
                                ref10.addItem(" "+buildref);
                        ref10.setSelectedIndex(8);
                        rlabel.setLabelFor(ref10);
                        datapanel_10.add(rlabel);
                        datapanel_10.add(ref10);
                        mindistinput_10 = new JTextField("0",2);
                        JLabel label3 = new JLabel("Min Dist from end of RF:");
                        label3.setLabelFor(mindistinput_10);
                        maxdistinput_10 = new JTextField("0",2);
                        JLabel label4 = new JLabel("Max Dist from end of RF:");
                        datapanel_10.add(label3);
                        datapanel_10.add(mindistinput_10);
                        datapanel_10.add(label4);
                        datapanel_10.add(maxdistinput_10);
                        document_sequence_textfield_10 = sequence_textfield_10.getDocument();
                        document_minimum_allowed_spacing_10 = mindistinput_10.getDocument();
                        document_maximum_allowed_spacing_10 = maxdistinput_10.getDocument();
                        document_maximum_mismatch_10 = mismatchinput_10.getDocument();
                        document_sequence_textfield_10.addDocumentListener(new DocumentHandler());
                        document_maximum_mismatch_10.addDocumentListener(new DocumentHandler());
                        document_minimum_allowed_spacing_10.addDocumentListener(new DocumentHandler());
                        document_maximum_allowed_spacing_10.addDocumentListener(new DocumentHandler());

                }
                //---------------- Start Input of File Location

                JPanel bottom_left_panel = new JPanel();
                bottom_left_panel.setSize(300,100);
                bottom_left_panel.setLayout(new BoxLayout(bottom_left_panel, BoxLayout.Y_AXIS));
                if (files_to_search == null)
                        pathlabel = new JLabel("Currently no files to search.");
                else 
                {
                        if (searchtype == 2) pathlabel = new JLabel("Internet source, local list: "+ files_to_search[0].getName());
                        else pathlabel = new JLabel("You have chosen to search "+files_to_search.length + " files, in directory: "+files_to_search[0].getPath());
                }
                bottom_left_panel.add(pathlabel);
                change_file_to_be_searched = new JButton("Change File(s)/List");
                bottom_left_panel.add(change_file_to_be_searched);
                change_file_to_be_searched.addActionListener(this);
                bottomsection.add(bottom_left_panel);
                //---------------- End Input of File Location
                //---------------- Begin Filtering Questions
                RadioListener myListener = new RadioListener();
                JPanel bottom_right_panel = new JPanel();
                bottom_right_panel.setSize(300, 100);
                bottom_right_panel.setLayout(new GridLayout(6, 2));
                should_results_be_parsed = new JCheckBox("Parse the results?", shouldparse);
                should_results_be_parsed.setActionCommand(parsechange);
                should_results_be_parsed.addChangeListener(myListener);
                bottom_right_panel.add(should_results_be_parsed);
                strandfilter = new JComboBox();
                strandfilter.addItem("No Strand Filter");
                strandfilter.addItem("Forward Strand Only");
                strandfilter.addItem("Complement Strand Only");
                bottom_right_panel.add(strandfilter);
                parsefilter = new JComboBox();
                parsefilter.addItem("No Parse Filter");
                parsefilter.addItem("Extragenic only");
                parsefilter.addItem("In ORF only");
                parsefilter.addItem("In Intron only");
                parsefilter.addItem("Extragenic/Intron only");
                bottom_right_panel.add(parsefilter);
                cancelbutton = new JButton("Cancel");
                cancelbutton.addActionListener(this);
                okbutton = new JButton("Proceed");
                okbutton.setEnabled(false);
                okbutton.addActionListener(this);
                infobutton = new JButton("Nucleotide Chart");
                infobutton.addActionListener(this);
                bottom_right_panel.add(okbutton);
                bottom_right_panel.add(cancelbutton);
                bottom_right_panel.add(infobutton);
                bottomsection.add(bottom_right_panel);
                this.addWindowListener(new WindowAdapter()
                                       {
                                               public void windowClosing(WindowEvent e)
                                               {
                                                       datagathered = false;
                                               }
                                       }
                                      );
        }
        class DocumentHandler implements DocumentListener
        {

                public void insertUpdate(DocumentEvent event)
                {
                        if (numiterations == 1)
                        {
                                if (verify_all_IUPAC(sequence_textfield_1) == true &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) == true && have_file_path == true)
                                {
                                        okbutton.setEnabled(true);
                                }
                                else
                                        okbutton.setEnabled(false);
                        }
                        else if (numiterations == 2)
                        {
                                if (have_file_path == true && verify_all_IUPAC(sequence_textfield_1) == true &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) == true &&
                                        verify_all_IUPAC(sequence_textfield_2) == true &&
                                        verify_number_greater_than_length(mismatchinput_2, sequence_textfield_2) == true &&
                                        verify_valid_number(mindistinput_2) == true && verify_valid_number(maxdistinput_2) == true)
                                {
                                        okbutton.setEnabled(true);
                                }
                                else
                                        okbutton.setEnabled(false);
                        }
                        else if (numiterations == 3)
                        {
                                if (have_file_path == true && verify_all_IUPAC(sequence_textfield_1) && verify_all_IUPAC(sequence_textfield_2) &&
                                        verify_all_IUPAC(sequence_textfield_3) &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) &&
                                        verify_number_greater_than_length(mismatchinput_2, sequence_textfield_2) &&
                                        verify_number_greater_than_length(mismatchinput_3, sequence_textfield_3) &&
                                        verify_valid_number(mindistinput_2) && verify_valid_number(mindistinput_3) &&
                                        verify_valid_number(maxdistinput_2) && verify_valid_number(maxdistinput_3))
                                {
                                        okbutton.setEnabled(true);
                                }
                                else
                                        okbutton.setEnabled(false);
                        }
                        else if (numiterations == 4)
                        {
                                if (have_file_path == true && verify_all_IUPAC(sequence_textfield_1) && verify_all_IUPAC(sequence_textfield_2) &&
                                        verify_all_IUPAC(sequence_textfield_3) &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) &&
                                        verify_number_greater_than_length(mismatchinput_2, sequence_textfield_2) &&
                                        verify_number_greater_than_length(mismatchinput_3, sequence_textfield_3) &&
                                        verify_valid_number(mindistinput_2) && verify_valid_number(mindistinput_3) &&
                                        verify_valid_number(maxdistinput_2) && verify_valid_number(maxdistinput_3) &&
                                        verify_all_IUPAC(sequence_textfield_4) &&
                                        verify_number_greater_than_length(mismatchinput_4, sequence_textfield_4) &&
                                        verify_valid_number(mindistinput_4) && verify_valid_number(maxdistinput_4))
                                {
                                        okbutton.setEnabled(true);
                                }
                                else
                                        okbutton.setEnabled(false);
                        }
                        else if (numiterations == 5)
                        {
                                if (have_file_path == true && verify_all_IUPAC(sequence_textfield_1) && verify_all_IUPAC(sequence_textfield_2) &&
                                        verify_all_IUPAC(sequence_textfield_3) &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) &&
                                        verify_number_greater_than_length(mismatchinput_2, sequence_textfield_2) &&
                                        verify_number_greater_than_length(mismatchinput_3, sequence_textfield_3) &&
                                        verify_valid_number(mindistinput_2) && verify_valid_number(mindistinput_3) &&
                                        verify_valid_number(maxdistinput_2) && verify_valid_number(maxdistinput_3) &&
                                        verify_all_IUPAC(sequence_textfield_4) &&
                                        verify_number_greater_than_length(mismatchinput_4, sequence_textfield_4) &&
                                        verify_valid_number(mindistinput_4) && verify_valid_number(maxdistinput_4) &&
                                        verify_all_IUPAC(sequence_textfield_5) &&
                                        verify_number_greater_than_length(mismatchinput_5, sequence_textfield_5) &&
                                        verify_valid_number(mindistinput_5) && verify_valid_number(maxdistinput_5))
                                {
                                        okbutton.setEnabled(true);
                                }
                                else
                                        okbutton.setEnabled(false);
                        }
                        else if (numiterations == 6)
                        {
                                if (have_file_path == true && verify_all_IUPAC(sequence_textfield_1) && verify_all_IUPAC(sequence_textfield_2) &&
                                        verify_all_IUPAC(sequence_textfield_3) &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) &&
                                        verify_number_greater_than_length(mismatchinput_2, sequence_textfield_2) &&
                                        verify_number_greater_than_length(mismatchinput_3, sequence_textfield_3) &&
                                        verify_valid_number(mindistinput_2) && verify_valid_number(mindistinput_3) &&
                                        verify_valid_number(maxdistinput_2) && verify_valid_number(maxdistinput_3) &&
                                        verify_all_IUPAC(sequence_textfield_4) &&
                                        verify_number_greater_than_length(mismatchinput_4, sequence_textfield_4) &&
                                        verify_valid_number(mindistinput_4) && verify_valid_number(maxdistinput_4) &&
                                        verify_all_IUPAC(sequence_textfield_5) &&
                                        verify_number_greater_than_length(mismatchinput_5, sequence_textfield_5) &&
                                        verify_valid_number(mindistinput_5) && verify_valid_number(maxdistinput_5) &&
                                        verify_all_IUPAC(sequence_textfield_6) &&
                                        verify_number_greater_than_length(mismatchinput_6, sequence_textfield_6) &&
                                        verify_valid_number(mindistinput_6) && verify_valid_number(maxdistinput_6))
                                {
                                        okbutton.setEnabled(true);
                                }
                                else
                                        okbutton.setEnabled(false);
                        }
                        else if (numiterations == 7)
                        {
                                if (have_file_path == true && verify_all_IUPAC(sequence_textfield_1) && verify_all_IUPAC(sequence_textfield_2) &&
                                        verify_all_IUPAC(sequence_textfield_3) &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) &&
                                        verify_number_greater_than_length(mismatchinput_2, sequence_textfield_2) &&
                                        verify_number_greater_than_length(mismatchinput_3, sequence_textfield_3) &&
                                        verify_valid_number(mindistinput_2) && verify_valid_number(mindistinput_3) &&
                                        verify_valid_number(maxdistinput_2) && verify_valid_number(maxdistinput_3) &&
                                        verify_all_IUPAC(sequence_textfield_4) &&
                                        verify_number_greater_than_length(mismatchinput_4, sequence_textfield_4) &&
                                        verify_valid_number(mindistinput_4) && verify_valid_number(maxdistinput_4) &&
                                        verify_all_IUPAC(sequence_textfield_5) &&
                                        verify_number_greater_than_length(mismatchinput_5, sequence_textfield_5) &&
                                        verify_valid_number(mindistinput_5) && verify_valid_number(maxdistinput_5) &&
                                        verify_all_IUPAC(sequence_textfield_6) &&
                                        verify_number_greater_than_length(mismatchinput_6, sequence_textfield_6) &&
                                        verify_valid_number(mindistinput_6) && verify_valid_number(maxdistinput_6) &&
                                        verify_all_IUPAC(sequence_textfield_7) &&
                                        verify_number_greater_than_length(mismatchinput_7, sequence_textfield_7) &&
                                        verify_valid_number(mindistinput_7) && verify_valid_number(maxdistinput_7))
                                {
                                        okbutton.setEnabled(true);
                                }
                                else
                                        okbutton.setEnabled(false);
                        }
                        else if (numiterations == 8)
                        {
                                if (have_file_path == true && verify_all_IUPAC(sequence_textfield_1) && verify_all_IUPAC(sequence_textfield_2) &&
                                        verify_all_IUPAC(sequence_textfield_3) &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) &&
                                        verify_number_greater_than_length(mismatchinput_2, sequence_textfield_2) &&
                                        verify_number_greater_than_length(mismatchinput_3, sequence_textfield_3) &&
                                        verify_valid_number(mindistinput_2) && verify_valid_number(mindistinput_3) &&
                                        verify_valid_number(maxdistinput_2) && verify_valid_number(maxdistinput_3) &&
                                        verify_all_IUPAC(sequence_textfield_4) &&
                                        verify_number_greater_than_length(mismatchinput_4, sequence_textfield_4) &&
                                        verify_valid_number(mindistinput_4) && verify_valid_number(maxdistinput_4) &&
                                        verify_all_IUPAC(sequence_textfield_5) &&
                                        verify_number_greater_than_length(mismatchinput_5, sequence_textfield_5) &&
                                        verify_valid_number(mindistinput_5) && verify_valid_number(maxdistinput_5) &&
                                        verify_all_IUPAC(sequence_textfield_6) &&
                                        verify_number_greater_than_length(mismatchinput_6, sequence_textfield_6) &&
                                        verify_valid_number(mindistinput_6) && verify_valid_number(maxdistinput_6) &&
                                        verify_all_IUPAC(sequence_textfield_7) &&
                                        verify_number_greater_than_length(mismatchinput_7, sequence_textfield_7) &&
                                        verify_valid_number(mindistinput_7) && verify_valid_number(maxdistinput_7) &&
                                        verify_all_IUPAC(sequence_textfield_8) &&
                                        verify_number_greater_than_length(mismatchinput_8, sequence_textfield_8) &&
                                        verify_valid_number(mindistinput_8) && verify_valid_number(maxdistinput_8))
                                {
                                        okbutton.setEnabled(true);
                                }
                                else
                                        okbutton.setEnabled(false);
                        }

                        else if (numiterations == 9)
                        {
                                if (have_file_path == true && verify_all_IUPAC(sequence_textfield_1) && verify_all_IUPAC(sequence_textfield_2) &&
                                        verify_all_IUPAC(sequence_textfield_3) &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) &&
                                        verify_number_greater_than_length(mismatchinput_2, sequence_textfield_2) &&
                                        verify_number_greater_than_length(mismatchinput_3, sequence_textfield_3) &&
                                        verify_valid_number(mindistinput_2) && verify_valid_number(mindistinput_3) &&
                                        verify_valid_number(maxdistinput_2) && verify_valid_number(maxdistinput_3) &&
                                        verify_all_IUPAC(sequence_textfield_4) &&
                                        verify_number_greater_than_length(mismatchinput_4, sequence_textfield_4) &&
                                        verify_valid_number(mindistinput_4) && verify_valid_number(maxdistinput_4) &&
                                        verify_all_IUPAC(sequence_textfield_5) &&
                                        verify_number_greater_than_length(mismatchinput_5, sequence_textfield_5) &&
                                        verify_valid_number(mindistinput_5) && verify_valid_number(maxdistinput_5) &&
                                        verify_all_IUPAC(sequence_textfield_6) &&
                                        verify_number_greater_than_length(mismatchinput_6, sequence_textfield_6) &&
                                        verify_valid_number(mindistinput_6) && verify_valid_number(maxdistinput_6) &&
                                        verify_all_IUPAC(sequence_textfield_7) &&
                                        verify_number_greater_than_length(mismatchinput_7, sequence_textfield_7) &&
                                        verify_valid_number(mindistinput_7) && verify_valid_number(maxdistinput_7) &&
                                        verify_all_IUPAC(sequence_textfield_8) &&
                                        verify_number_greater_than_length(mismatchinput_8, sequence_textfield_8) &&
                                        verify_valid_number(mindistinput_8) && verify_valid_number(maxdistinput_8) &&
                                        verify_all_IUPAC(sequence_textfield_9) &&
                                        verify_number_greater_than_length(mismatchinput_9, sequence_textfield_9) &&
                                        verify_valid_number(maxdistinput_9) && verify_valid_number(mindistinput_9))
                                {
                                        okbutton.setEnabled(true);

                                }
                                else
                                        okbutton.setEnabled(false);
                        }
                        else if (numiterations == 10)
                        {
                                if (have_file_path == true && verify_all_IUPAC(sequence_textfield_1) && verify_all_IUPAC(sequence_textfield_2) &&
                                        verify_all_IUPAC(sequence_textfield_3) &&
                                        verify_number_greater_than_length(mismatchinput_1, sequence_textfield_1) &&
                                        verify_number_greater_than_length(mismatchinput_2, sequence_textfield_2) &&
                                        verify_number_greater_than_length(mismatchinput_3, sequence_textfield_3) &&
                                        verify_valid_number(mindistinput_2) && verify_valid_number(mindistinput_3) &&
                                        verify_valid_number(maxdistinput_2) && verify_valid_number(maxdistinput_3) &&
                                        verify_all_IUPAC(sequence_textfield_4) &&
                                        verify_number_greater_than_length(mismatchinput_4, sequence_textfield_4) &&
                                        verify_valid_number(mindistinput_4) && verify_valid_number(maxdistinput_4) &&
                                        verify_all_IUPAC(sequence_textfield_5) &&
                                        verify_number_greater_than_length(mismatchinput_5, sequence_textfield_5) &&
                                        verify_valid_number(mindistinput_5) && verify_valid_number(maxdistinput_5) &&
                                        verify_all_IUPAC(sequence_textfield_6) &&
                                        verify_number_greater_than_length(mismatchinput_6, sequence_textfield_6) &&
                                        verify_valid_number(mindistinput_6) && verify_valid_number(maxdistinput_6) &&
                                        verify_all_IUPAC(sequence_textfield_7) &&
                                        verify_number_greater_than_length(mismatchinput_7, sequence_textfield_7) &&
                                        verify_valid_number(mindistinput_7) && verify_valid_number(maxdistinput_7) &&
                                        verify_all_IUPAC(sequence_textfield_8) &&
                                        verify_number_greater_than_length(mismatchinput_8, sequence_textfield_8) &&
                                        verify_valid_number(mindistinput_8) && verify_valid_number(maxdistinput_8) &&
                                        verify_all_IUPAC(sequence_textfield_9) &&
                                        verify_number_greater_than_length(mismatchinput_9, sequence_textfield_9) &&
                                        verify_valid_number(maxdistinput_9) && verify_valid_number(mindistinput_9) &&
                                        verify_all_IUPAC(sequence_textfield_10) &&
                                        verify_number_greater_than_length(mismatchinput_10, sequence_textfield_10) &&
                                        verify_valid_number(maxdistinput_10) && verify_valid_number(mindistinput_10))
                                {
                                        okbutton.setEnabled(true);
                                        
                                }
                                else
                                        okbutton.setEnabled(false);
                        }
                }

                // Handle deletions	from the text field
                public void removeUpdate(DocumentEvent event)
                {
                        insertUpdate(event);
                }

                // Handle changes to the text field
                public void changedUpdate(DocumentEvent event)
                {
                        insertUpdate(event);
                }
        }

        class RadioListener implements ActionListener, ChangeListener
        {
                public void actionPerformed(ActionEvent e)
                {

                        if (e.getActionCommand() == parsechange)
                        {
                                shouldparse = should_results_be_parsed.isSelected();
                        }
                }

                public void stateChanged(ChangeEvent e)
                {

                        if (e.getSource() == parsechange)
                        {
                                shouldparse = should_results_be_parsed.isSelected();
                        }
                }
        }

        public void actionPerformed(ActionEvent event)
        {
                if (event.getSource() == change_file_to_be_searched)
                {
                                    
                        JOptionPane which_type_of_search = new JOptionPane();
                        Object[] possibleValues = new Object[]{"Forget it", "Local File or Files", "Pull Files from NCBI"};
                        Object selectedValue =
                                which_type_of_search.showInputDialog(this, "Which type of search is this?", "Question", JOptionPane.QUESTION_MESSAGE,
                                null, possibleValues, possibleValues[0]);
                        if (selectedValue == "Local File or Files")
                        {
                                JFileChooser fileChooser = new JFileChooser("Select File(s)");
                                fileChooser.setMultiSelectionEnabled(true);
                                fileChooser.setApproveButtonText("Select File(s)");
                                int returnValue = fileChooser.showOpenDialog(this);
                                if (returnValue == JFileChooser.APPROVE_OPTION)
                                {
                                        files_to_search = fileChooser.getSelectedFiles();
                                        have_file_path = true;
                                        pathlabel.setText("You have chosen to search "+files_to_search.length + " files");
                                        searchtype = 1;
                                }
                        }
                        if (selectedValue == "Pull Files from NCBI")
                        {
                                JFileChooser fileChooser = new JFileChooser("Select File(s)");
                                fileChooser.setMultiSelectionEnabled(true);
                                fileChooser.setApproveButtonText("Select File(s)");
                                int returnValue = fileChooser.showOpenDialog(this);
                                if (returnValue == JFileChooser.APPROVE_OPTION)
                                {
                                        files_to_search = fileChooser.getSelectedFiles();
                                        have_file_path = true;
                                        pathlabel.setText("You have chosen to search "+files_to_search.length + " files");
                                        searchtype = 2;
                                }
                        }


                }


                if (event.getSource() == infobutton)
                {
                        achart = new Chart();
                        achart.setModal(false);
                        achart.setVisible(true);
                }

                if (event.getSource() == cancelbutton)
                {
                        this.dispose();
                }
                if (event.getSource() == okbutton)
                {
                        datagathered = true;
                        shouldparse = should_results_be_parsed.isSelected();
                        sequence_fragment[0] = sequence_textfield_1.getText();
                        mismatch[0] = Integer.parseInt(mismatchinput_1.getText());

                        strandfilt = strandfilter.getSelectedIndex();
                        parsefilt = parsefilter.getSelectedIndex();
                        //liststatnum = liststats.getSelectedIndex();
                        if (numiterations > 1)
                        {
                                sequence_fragment[1] = sequence_textfield_2.getText();
                                mismatch[1] = Integer.parseInt(mismatchinput_2.getText());
                                mindist[1] = Integer.parseInt(mindistinput_2.getText());
                                maxdist[1] = Integer.parseInt(maxdistinput_2.getText());
                        }
                        if (numiterations > 2)
                        {
                                sequence_fragment[2] = sequence_textfield_3.getText();
                                mismatch[2] = Integer.parseInt(mismatchinput_3.getText());
                                mindist[2] = Integer.parseInt(mindistinput_3.getText());
                                maxdist[2] = Integer.parseInt(maxdistinput_3.getText());
                                relative_to_which_fragment[2] = (ref3.getSelectedIndex());
                        }
                        if (numiterations > 3)
                        {
                                sequence_fragment[3] = sequence_textfield_4.getText();
                                mismatch[3] = Integer.parseInt(mismatchinput_4.getText());
                                mindist[3] = Integer.parseInt(mindistinput_4.getText());
                                maxdist[3] = Integer.parseInt(maxdistinput_4.getText());
                                relative_to_which_fragment[3] = (ref4.getSelectedIndex());
                        }
                        if (numiterations > 4)
                        {
                                sequence_fragment[4] = sequence_textfield_5.getText();
                                mismatch[4] = Integer.parseInt(mismatchinput_5.getText());
                                mindist[4] = Integer.parseInt(mindistinput_5.getText());
                                maxdist[4] = Integer.parseInt(maxdistinput_5.getText());
                                relative_to_which_fragment[4] = (ref5.getSelectedIndex());
                        }
                        if (numiterations > 5)
                        {
                                sequence_fragment[5] = sequence_textfield_6.getText();
                                mismatch[5] = Integer.parseInt(mismatchinput_6.getText());
                                mindist[5] = Integer.parseInt(mindistinput_6.getText());
                                maxdist[5] = Integer.parseInt(maxdistinput_6.getText());
                                relative_to_which_fragment[5] = (ref6.getSelectedIndex());
                        }
                        if (numiterations > 6)
                        {
                                sequence_fragment[6] = sequence_textfield_7.getText();
                                mismatch[6] = Integer.parseInt(mismatchinput_7.getText());
                                mindist[6] = Integer.parseInt(mindistinput_7.getText());
                                maxdist[6] = Integer.parseInt(maxdistinput_7.getText());
                                relative_to_which_fragment[6] = (ref7.getSelectedIndex());
                        }
                        if (numiterations > 7)
                        {
                                sequence_fragment[7] = sequence_textfield_8.getText();
                                mismatch[7] = Integer.parseInt(mismatchinput_8.getText());
                                mindist[7] = Integer.parseInt(mindistinput_8.getText());
                                maxdist[7] = Integer.parseInt(maxdistinput_8.getText());
                                relative_to_which_fragment[7] = (ref8.getSelectedIndex());
                        }
                        if (numiterations > 8)
                        {
                                sequence_fragment[8] = sequence_textfield_9.getText();
                                mismatch[8] = Integer.parseInt(mismatchinput_9.getText());
                                mindist[8] = Integer.parseInt(mindistinput_9.getText());
                                maxdist[8] = Integer.parseInt(maxdistinput_9.getText());
                                relative_to_which_fragment[8] = (ref9.getSelectedIndex());
                        }
                        if (numiterations > 10)
                        {
                                sequence_fragment[9] = sequence_textfield_10.getText();
                                mismatch[9] = Integer.parseInt(mismatchinput_10.getText());
                                mindist[9] = Integer.parseInt(mindistinput_10.getText());
                                maxdist[9] = Integer.parseInt(maxdistinput_10.getText());
                                relative_to_which_fragment[9] = (ref10.getSelectedIndex());
                        }
                        this.dispose();

                }
        }

        public boolean verify_valid_number(JTextField docin)
        {

                if (docin.getText().length() == 0)
                        return false;
                try
                {
                        String strin = docin.getText();
                        int iValue = Integer.parseInt(strin);

                        if (iValue < 0)
                                return false;
                        return true;
                }
                catch (NumberFormatException e)
                {
                        return false;
                }

        }


        public boolean verify_all_IUPAC(JTextField docin)
        {

                if (docin.getText().length() == 0)
                        return false;
                try
                {

                        String strin = docin.getText();
                        strin = strin.trim();
                        char[] xworking = strin.toCharArray();
                        for (int y = 0; y < (xworking.length); y++)
                        {

                                if (!Character.isLetter(xworking[y]))
                                        return false;
                                if (xworking[y] != 'A' && xworking[y] != 'a' && xworking[y] != 'T' && xworking[y] != 't' && xworking[y] != 'C' &&
                                        xworking[y] != 'c' && xworking[y] != 'G' && xworking[y] != 'g' && xworking[y] != 'M' && xworking[y] != 'm' &&
                                        xworking[y] != 'R' && xworking[y] != 'r' && xworking[y] != 'W' && xworking[y] != 'w' && xworking[y] != 'S' &&
                                        xworking[y] != 's' && xworking[y] != 'Y' && xworking[y] != 'y' && xworking[y] != 'K' && xworking[y] != 'k' &&
                                        xworking[y] != 'V' && xworking[y] != 'v' && xworking[y] != 'H' && xworking[y] != 'h' && xworking[y] != 'D' &&
                                        xworking[y] != 'd' && xworking[y] != 'B' && xworking[y] != 'b' && xworking[y] != 'N' && xworking[y] != 'n')
                                        return false;
                        }

                        return true;
                }
                catch (NumberFormatException e)
                {
                        return false;
                }
                catch (NullPointerException e)
                {
                        return false;
                }
        }

        public int calculate_length_of_String(JTextField innum)
        {
                if (innum.getText().length() == 0)
                        return 0;
                String str = innum.getText();
                char[] chars = str.toCharArray();
                for (int xx = 0; xx < chars.length; xx++)
                {
                        if (!(Character.isDigit(chars[xx])))
                        {
                                return chars.length;
                        }
                }
                return Integer.parseInt(str);
        }

        public boolean verify_number_greater_than_length(JTextField innum, JTextField inseq)
        {
                if (innum.getText().length() == 0)
                        return false;
                if (inseq.getText().length() == 0)
                        return false;

                try
                {
                        String numstr = innum.getText();
                        numstr = numstr.trim();

                        String seqstr = inseq.getText();
                        seqstr = seqstr.trim();

                        char[] tworking = seqstr.toCharArray();
                        int iValue = Integer.parseInt(numstr);

                        if ((tworking.length) <= iValue)
                                return false;

                        return true;
                }
                catch (NumberFormatException e)
                {
                        return false;
                }
                catch (NullPointerException e)
                {
                        return false;
                }
        }

}















